goto start
:usage
echo off
cls
echo Ŀ
echo  asp_cd.bat -- Builds <product>.ASC file for           
echo                submitting product for ASP CD-ROM.      
echo                Also prepares checklist.                
echo                                                        
echo  usage:                                                
echo         asp_cd vendinfo_file                           
echo  where:                                                
echo         vendinfo_file = pathname of VENDINFO.DIZ file  
echo                                                        
echo  example:                                              
echo     asp_cd C:\VENDINFO.DIZ                             
echo                                                        
echo  NOTE: Invoke in directory in which you want files.    
echo        Remember to print and delete ASPPRINT.TMP.      
echo        VENDPRCS.EXE must be on your DOS path.          
echo                                                        
echo  From the VNDUTL VENDINFO Utilities, v1.10 (12/8/94)   
echo  Copyright 1994 Rams' Island Software, Parker, CO USA  
echo 
goto done

::----- check arguments -------------------------------------------
::-----    first argument must VENDINFO file pathname -------------
:start
if %1. == .        goto usage

:UpdateOK
if not exist %1    goto problem
goto argsOK

:argsOK
::----- test VENDINFO file ----------------------------------------   
vendprcs %1 -xppt
if errorlevel 52 goto viFileOK
goto problem

:viFileOK
::----- build ASPCD.TMP temporary program description file --------
vendprcs %1 -xppl -y "PROGRAM FILENAME: @.ZIP"           > ASPCD.TMP
vendprcs %1 -xpp -zn -y "PROGRAM NAME AND VERSION: @ v" >> ASPCD.TMP
vendprcs %1 -xpv                                        >> ASPCD.TMP
vendprcs %1 -xpp -zn -y "BRIEF DESCRIPTION: @ "         >> ASPCD.TMP
vendprcs %1 -xpe -zn -y "@ v"                           >> ASPCD.TMP
vendprcs %1 -xpv                                        >> ASPCD.TMP
vendprcs -y "LONG DESCRIPTION: SEE FILE_ID.DIZ"         >> ASPCD.TMP
vendprcs %1 -xpx -y "REPLACES: @"                       >> ASPCD.TMP

::----- rename ASPCD.TMP to <product>.ASC -------------------------
vendprcs %1 -xppl -y "del @.ASC"                         > TEMP.BAT
vendprcs %1 -xppl -y "ren ASPCD.TMP @.ASC"              >> TEMP.BAT
call TEMP.BAT
del TEMP.BAT

echo ============================================================================ > ASPPRINT.TMP
echo Checklist of preparation steps for ASP CD-ROM submission: >> ASPPRINT.TMP
echo ============================================================================ >> ASPPRINT.TMP
vendprcs -y " " >> ASPPRINT.TMP
vendprcs %1 -xppl -y " [ ] Prepare @.ZIP package, with embedded FILE_ID.DIZ file." >> ASPPRINT.TMP
vendprcs -y " " >> ASPPRINT.TMP
vendprcs %1 -xppl -y " [ ] Create @.ASC file for submission with ZIP file. >> ASPPRINT.TMP
echo      (This was just done for you by the ASP_CD.BAT program.) >> ASPPRINT.TMP
vendprcs -y " " >> ASPPRINT.TMP
vendprcs %1 -xppl -y " [ ] Use ASCII editor to verify contents of @.ASC file. >> ASPPRINT.TMP
echo      (You may, for example, want to modify the brief description.) >> ASPPRINT.TMP
vendprcs -y " " >> ASPPRINT.TMP
echo  [ ] Place both files on a (preferably 3-1/2) diskette. >> ASPPRINT.TMP
echo      (You may include multiple *.ZIP and *.ASC files on one diskette.) >> ASPPRINT.TMP
vendprcs -y " " >> ASPPRINT.TMP
echo  [ ] Send package to: >> ASPPRINT.TMP
echo         RICH HARPER >> ASPPRINT.TMP
echo         ATTN: CD-ROM SUBMISSION      {-- IMPORTANT! Must be on envelope! >> ASPPRINT.TMP
echo         777 S. ROTH ST, NORFOLK 4 >> ASPPRINT.TMP
echo         REED CITY, MI  49677 >> ASPPRINT.TMP
echo         U.S.A. >> ASPPRINT.TMP
vendprcs -y " " >> ASPPRINT.TMP
echo ============================================================================ >> ASPPRINT.TMP
echo                                                      Produced by VNDUTL 1.10 >> ASPPRINT.TMP
goto done

:problem
@echo off
cls
echo Specified VENDINFO file
echo    (%1)
echo does not exist, or is corrupted, unregistered, or has some other
echo difficulty.
goto done

:done
