*  BOF: NETAPPEN.CH

*  FILE.......: NETAPPEN.CH
*  AUTHOR.....: Berend Tober
*  CIS id #...: 70541,1030
*  DATE.......: Wed  94/08/10 13:00:53

/* Modification History
*/


 * File......: NetAppen.CH
 * Author....: Berend M. Tober
 * CIS ID....: 700541,1030
 * Date......: $Date$
 * Revision..: $Revision$
 * Log file..: $Logfile$
 * 
 * Modification history:
 * ---------------------
 *
 * $Log$
 *
 */


/*  $DOC$
 *  $FUNCNAME$
 *     NetAppend()
 *  $CATEGORY$
 *     Networks
 *  $ONELINER$
 *     Attempt to APPEND BLANK with optional retry.
 *  $SYNTAX$
 *     NetAppend( [<nSec>] ) --> lSuccess
 *  $ARGUMENTS$
 *     [<nSec>] time in seconds to retry operation.
 *  $RETURNS$
 *     TRUE if successful, false FALSE otherwise.
 *  $DESCRIPTION$
 *     Persistent attempt to APPEND BLANK with optional retry.
 *  $EXAMPLES$
 *     lSuccess := NetAppend()
 *  $SEEALSO$
 *     NetMode NetRLock NetFlock NetDelete NetUse
 *  $INCLUDE$
 *  $END$
 */

********************************* NetAppend() **********************************
#xtranslate NetAppend([<nSec>]) => NetPersist({||DBAPPEND(), !NETERR()}, <nSec>)

* EOF: NETAPPEN.CH

